import unittest

from fancymath.vector import Vector


class TestVector(unittest.TestCase):
    def test_cross_product(self):
        # given
        v1 = Vector(1, 2, 3)
        v2 = Vector(3, 2, 1)

        # when
        v3 = v1 * v2

        # then
        self.assertIsInstance(v3, Vector)
        self.assertEqual(v3.x, -4)
        self.assertEqual(v3.y, 8)
        self.assertEqual(v3.z, -4)

    def test_cross_product_failure(self):
        v1 = Vector(1, 2, 3)
        v2 = (3, 2, 1)

        with self.assertRaises(TypeError):
            v1 * v2


    def test_add_vector(self):
        v1 = Vector(1, 2, 3)
        v2 = Vector(-3, -2, -1)
        v3 = v1 + v2
        self.assertIsInstance(v3, Vector)
        self.assertEqual(v3.x, v1.x + v2.x)
        
    def test_dot_failure(self):
        with self.assertRaises(ValueError):
            v1 = Vector(1, 2, 3)
            v1.dot(3)

    def test_dot_product(self):
        v1 = Vector(1, 2, 3)
        v2 = Vector(-3, -2, -1)
        v3 = v1.dot(v2)
        self.assertEqual(v3,v1.x * v2.x + v1.y * v2.y + v1.z * v2.z)
        vzero = Vector(0, 0, 0)
        self.assertEqual(v1.dot(vzero),0)
